#Wdescriptivo.py: Este widget es el que representa las medidas descriptivas.

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA



#Los eleementos que posee son:
#ListBox1: Donde se guarda el listado total de variables
#ListBox2: Listado de variables actualmente seleccionada
#pushButton1: Boton listado1 -> listado2
#pushButton2: Boton listado1 <- listado2
#pushButton3: Aceptar
#pushButton4: Cancelar


#checkBox1: Media?
#checkBox2: Moda?
#checkBox3: Varianza?

#Este widget tiene que conseguir enviar información a la interfaz de salida. Enviara lo siguiente:
# -Arrays de nombre de variables
# -Diccionario con las opciones


from uiwdescriptivo import WidgetDescriptivo
from qt import *

class WDescriptivo(WidgetDescriptivo):
	""" Widget para calculos descriptivos"""
	def __init__(self,parent = None,name = None,fl = 0):
		WidgetDescriptivo.__init__(self,parent,name,fl)
		self.__conexiones()
		self.seleccion=[] #La seleccion que ya se ha hecho. (Solo los nombres)
		self.dialogopadre=parent.parent().parent().parent()
		self.driza=parent.parent().parent().parent().parent().parent()

	def __conexiones(self):
		"""Bloque de conexiones del widget descriptivo"""
		self.connect(self.pushButton1,SIGNAL("clicked()"),self.__addelemento)
		self.connect(self.pushButton2,SIGNAL("clicked()"),self.__delelemento)
		self.connect(self.pushButton3,SIGNAL("clicked()"),self.__aceptar)
		self.connect(self.pushButton4,SIGNAL("clicked()"),self.__cancelar)

		#SLOTS
	def __aceptar(self):
		"""Aceptacion del dialogo. 
		Empleamos diccionario para guardar las opciones
		Comprobamos que hay variables y operaciones seleccionadas
		"""
		#Comprobamos que hay alguna variable seleccionada
		if not self.seleccion:
			rc = QMessageBox.warning(self,'Atencion', 'No hay ninguna variable seleccionada', 'Volver al dialogo','Salir','',0,1 )
			if rc==1:
				self.dialogopadre.reject()
		#Comprobamos que hay alguna operacion seleccionada
		elif not self.checkBox1.isChecked() and not self.checkBox2.isChecked() and not self.checkBox3.isChecked():
			rc = QMessageBox.warning(self,'Atencion', 'No hay ninguna operación seleccionada', 'Volver al dialogo','Salir','',0,1 )
			if rc==1:
				self.dialogopadre.reject()
		else:
			diccionario={"media":False,"varianza":False,"moda":False}
			if self.checkBox1.isChecked():
				diccionario["media"]=True
			if self.checkBox2.isChecked():
				diccionario["varianza"]=True
			if self.checkBox3.isChecked():
				diccionario["moda"]=True
			self.driza.calcular("descriptivo",self.seleccion,diccionario)
			self.dialogopadre.accept()

	def __cancelar(self):
		"""Cancelacion del dialogo"""
		self.dialogopadre.reject()

	def show(self):
		self.__showcaja1()
		self.__showcaja2()
		WidgetDescriptivo.show(self)

	def __addelemento(self):
		#Obtener elemento de la seleccion de la lista1
		self.seleccion.append(self.listBox1.currentText())
		self.__showcaja1()
		self.__showcaja2()
	def __delelemento(self):
		#Obtener elemento de la seleccion de la lista1
		i=self.listBox2.currentItem()
		self.seleccion.remove(self.listBox2.currentText())
		self.__showcaja1()
		self.__showcaja2()
	def __showcaja1(self):
		self.listBox1.clear()
		i=0
		for var in self.driza.dato.arr_tit():
			if not var in self.seleccion:
				self.listBox1.insertItem(var,i)
				i+=1

	def __showcaja2(self):
		self.listBox2.clear()
		i=0
		for var in self.seleccion:
			self.listBox2.insertItem(var,i)
			i+=1

