from uidcrevar import DialogoCrevar
from qt import *

#Dialogo de creacion de variables


#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#listbox1: Variables disponibles
#pushButton1: Boton de inclusion de variable en caja de texto
#textEdit1: Caja de escritura
#pushButton2: aceptar
#pushButton3: cancelar
#pushButton4 Inclusión de función en caja de texto
#listbox2: listado categoria funciones
#listbox3: listado funciones
#lineEdit2: Caja con el nombre de la variable




class DCrevar(DialogoCrevar):
	"""Dialogo que crea unas variables a partir de otras"""
	def __init__(self,parent=None,name=None,modal=0,fl=0):
		self.driza=parent.parent()
		DialogoCrevar.__init__(self,parent,name,modal,fl)
		self.__conexiones()
	

	def __conexiones(self):
		self.connect(self.pushButton1,SIGNAL("clicked()"),self.__nombrecaja)
		self.connect(self.pushButton2,SIGNAL("clicked()"),self.accept)
		self.connect(self.pushButton3,SIGNAL("clicked()"),self.cancel)

	def show(self):
		self.__actualizarcaja1()
		DialogoCrevar.show(self)


	def __actualizarcaja1(self):
		"""Actualiza la caja de variables disponibles"""
		self.listBox1.clear()
		i=0
		for var in self.driza.dato.arr_tit():
			self.listBox1.insertItem(var,i)
			i+=1
	
	def __nombrecaja(self):
		"""Coge el valor seleccionado y lo añade en la caja de texto"""
		if self.listBox1.currentItem() != -1:
			texto=self.listBox1.currentText().latin1()
			self.textEdit1.insert(texto)
	def accept(self):
		"""Funcion de aceptacion del dialogo"""
		# Creo un objeto con lo que me pasan a ver si hay una excepción o no
		guay=True
		try:
			compile(self.textEdit1.text().latin1(),self.driza.config["tmpdir"]+"/objetotmp",'single')
		except SyntaxError:
			#enseñarventana de aviso
			QErrorMessage(self,"error").message("No está bien la expresión")
			guay=False
		else:
			#llamar a la funcion de driza que crea la nueva variable
			self.driza.crearvariable(self.lineEdit2.text().latin1(),self.textEdit1.text().latin1())
			DialogoCrevar.accept(self)
#			import os
#			os.remove(self.driza.config["tmpdir"]+"/objetotmp") #borro el archivo ... No existe ... PENDIENTE
	def cancel(self):
		"""Función de cancelación"""
		self.reject()



