from uidfiltro import DialogoFiltro
from qt import *

#Dialogo de filtrado
#contiene una etiqueta con el nombre del filtro actual: textLabel
#Una caja que muestre las variables posibles:  listBox1
#Boton de acceso rapido a la creación de variables: pushButton1
#Boton de aceptación: pushButton2
#Boton de revocación: pushButton3
#Boton de cancelación: pushButton4


class DFiltro(DialogoFiltro):

	def __init__(self,parent=None,name=None,modal = 0,fl = 0):
		"""Inicializa el dialogo"""
		DialogoFiltro.__init__(self,parent,name,modal,fl)
		self.__inicializarlistbox()
		self.__conexiones()
		#Rellenar la lista con las variables booleanas

	def show(self):
		"""Llama al show de la clase base, pero previamente selecciona la variable que ya actua de filtro"""
		self.listBox1.clear()
		for x in self.parent().parent().dato.arr_tit_bool():
			self.listBox1.insertItem(x)  # Rellena con los valores actuales
		#Consulta del filtro actual al padre
		if self.parent().parent().filtro:
			self.listBox1.setSelected(self.parent().parent().dato.mat_var(self.parent().parent().filtro),True)
		DialogoFiltro.show(self)

	def __conexiones(self):
		"""Las conexiones """
		self.connect(self.pushButton2,SIGNAL("clicked()"),self.accept)
		self.connect(self.pushButton3,SIGNAL("clicked()"),self.accept)
		self.connect(self.pushButton4,SIGNAL("clicked()"),self.reject)
	def accept(self):
		"""Esta funcion redefine accept, activando el filtro en la clase principal driza"""
		if self.listBox1.currentItem()!=-1:
			self.parent().parent().filtro=self.parent().parent().dato.nom_var(self.listBox1.currentText().latin1())
		DialogoFiltro.accept(self)
		self.parent().show() #Que se muestre el nuevo filtro

	def reject(self):
		DialogoFiltro.reject(self)

	def __inicializarlistbox(self):
		"""Simplemente vacia la listbox"""
		self.listBox1.clear()
		self.listBox1.SelectionMode(QListBox.Single)

